'                                                                  
' Copyright  2013 Lidor Systems.
' All Rights Reserved.
'
' This SOFTWARE is provided "AS IS", WITHOUT WARRANTY OF ANY KIND.
' either express or implied.                        
'

Public Class Form1

#Region "Variables"
    Private randomInts As Integer() = Nothing
    Private nodeCount As Integer = 0
#End Region

#Region "Initialize"
    Public Sub New()
        InitializeComponent()

        CreateLabelContent()

        InitList()
    End Sub

    Private Sub CreateLabelContent()
        Dim content As [String] = "<div style=""font:Verdana,9,r"">In this sample we are demonstrating how to expand nodes by:<br></br>"
        content += "<b>   1. Position mouse cursor over node space</b><br></br>"
        content += "<b>   2. Clicking node's text</b><br></br><br></br>"
        content += "If you want to see how node expands in first case, just hover with mouse cursor over some node. After inital delay of 500ms, the node will expand.<br></br>"
        content += "In order to see the second case in action, first check the radio button on right panel to switch functionality. Then click inside text space of some node. In this case, the node will expand or collapse only when it is clickied inside its text space."
        content += "</div>"

        Me.labelInfo.Content = content
    End Sub

    Private Sub InitList()
        Me.treeView1.SuspendUpdate()

        nodeCount = 0

        ' Create set of random integer values used to generate random number of child nodes
        randomInts = CreateRandomInts()

        ' Create random tree hierarchy
        CreateNode(Me.treeView1.RootNode, "", 0)

        Me.treeView1.ResumeUpdate()
    End Sub

    Private Sub CreateNode(ByVal parentNode As LidorSystems.IntegralUI.Lists.TreeNode, ByVal prefix As [String], ByVal level As Integer)
        If level = 5 Then
            Return
        End If

        Dim limit As Integer = randomInts(nodeCount Mod 99)
        If level = 0 Then
            limit = 100
        End If

        Dim node As LidorSystems.IntegralUI.Lists.TreeNode = Nothing
        For i As Integer = 1 To limit
            node = New LidorSystems.IntegralUI.Lists.TreeNode("Node " & Convert.ToString(prefix) & i.ToString())

            parentNode.Nodes.Add(node)
            nodeCount += 1

            CreateNode(node, Convert.ToString(prefix) & i.ToString(), level + 1)
        Next
    End Sub

    Private Function CreateRandomInts() As Integer()
        Dim rand As Integer() = New Integer(99) {}
        Dim gen As New Random()
        For i As Integer = 0 To rand.Length - 1
            rand(i) = gen.[Next](0, 5)
        Next

        Return rand
    End Function
#End Region

#Region "Expand on Hover"
    Private Sub treeView1_ItemMouseHover(ByVal sender As Object, ByVal e As LidorSystems.IntegralUI.ObjectEventArgs) Handles treeView1.ItemMouseHover
        If rbExpandHover.Checked Then
            ' Check whether the object passed to this event is a TreeNode
            ' If it is a TreeNode, expand its content
            If TypeOf e.[Object] Is LidorSystems.IntegralUI.Lists.TreeNode Then
                Dim node As LidorSystems.IntegralUI.Lists.TreeNode = DirectCast(e.[Object], LidorSystems.IntegralUI.Lists.TreeNode)

                node.Expand()
            End If
        End If
    End Sub
#End Region

#Region "Expand on Click"
    Private Sub treeView1_Click(ByVal sender As Object, ByVal e As EventArgs) Handles treeView1.Click
        If rbExpandClick.Checked Then
            ' Retrieve the current position of mouse cursor
            Dim mousePos As Point = Me.treeView1.ContentPanel.PointToClient(Control.MousePosition)

            ' Get a node at which mouse cursor points to
            Dim node As LidorSystems.IntegralUI.Lists.TreeNode = Me.treeView1.GetNodeAt(mousePos)
            If node IsNot Nothing Then
                ' Retrieve the space of node text and check whether the click was made inside it
                ' If it is expand or collapse the node
                Dim textArea As RectangleF = node.TextRect
                If textArea.Contains(mousePos) Then
                    node.Toggle()
                End If
            End If
        End If
    End Sub
#End Region

End Class
